"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
function _ui() {
  const data = require("@teambit/ui");
  _ui = function () {
    return data;
  };
  return data;
}
function _react() {
  const data = _interopRequireWildcard(require("react"));
  _react = function () {
    return data;
  };
  return data;
}
function _uuid() {
  const data = require("uuid");
  _uuid = function () {
    return data;
  };
  return data;
}
function _uiFoundationUiNotifications() {
  const data = require("@teambit/ui-foundation.ui.notifications.notification-context");
  _uiFoundationUiNotifications = function () {
    return data;
  };
  return data;
}
function _uiFoundationUiNotifications2() {
  const data = require("@teambit/ui-foundation.ui.notifications.notification-center");
  _uiFoundationUiNotifications2 = function () {
    return data;
  };
  return data;
}
function _uiFoundationUiNotifications3() {
  const data = require("@teambit/ui-foundation.ui.notifications.store");
  _uiFoundationUiNotifications3 = function () {
    return data;
  };
  return data;
}
function _notificationReducer() {
  const data = require("./notification-reducer");
  _notificationReducer = function () {
    return data;
  };
  return data;
}
function _notifications() {
  const data = require("./notifications.aspect");
  _notifications = function () {
    return data;
  };
  return data;
}
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function (nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(arg) { var key = _toPrimitive(arg, "string"); return typeof key === "symbol" ? key : String(key); }
function _toPrimitive(input, hint) { if (typeof input !== "object" || input === null) return input; var prim = input[Symbol.toPrimitive]; if (prim !== undefined) { var res = prim.call(input, hint || "default"); if (typeof res !== "object") return res; throw new TypeError("@@toPrimitive must return a primitive value."); } return (hint === "string" ? String : Number)(input); }
/**
 * extension
 */
class NotificationUI {
  static async provider([uiRuntimeExtension]) {
    return new NotificationUI(uiRuntimeExtension);
  }
  constructor(uiRuntimeExtension) {
    _defineProperty(this, "dispatch", void 0);
    /** adds a full message to the log */
    _defineProperty(this, "add", (message, level) => {
      var _this$dispatch;
      const id = (0, _uuid().v1)();
      (_this$dispatch = this.dispatch) === null || _this$dispatch === void 0 || _this$dispatch.call(this, {
        type: 'add',
        content: {
          id,
          message,
          level,
          time: new Date().toISOString()
        }
      });
      return id;
    });
    /** adds a message with level "info" to the log */
    _defineProperty(this, "log", message => this.add(message, _uiFoundationUiNotifications3().MessageLevel.info));
    /** adds a message with level "warning" to the log */
    _defineProperty(this, "warn", message => this.add(message, _uiFoundationUiNotifications3().MessageLevel.warning));
    /** adds a message with level "error" to the log */
    _defineProperty(this, "error", message => this.add(message, _uiFoundationUiNotifications3().MessageLevel.error));
    /** adds a message with level "success" to the log */
    _defineProperty(this, "success", message => this.add(message, _uiFoundationUiNotifications3().MessageLevel.success));
    /** removes all notifications */
    _defineProperty(this, "clear", () => {
      var _this$dispatch2;
      (_this$dispatch2 = this.dispatch) === null || _this$dispatch2 === void 0 || _this$dispatch2.call(this, {
        type: 'clear'
      });
    });
    _defineProperty(this, "render", props => {
      // this code assumes a single place of render per instance of NotificationUI
      const [messages, dispatch] = (0, _react().useReducer)(_notificationReducer().notificationReducer, []);
      this.dispatch = dispatch;
      return /*#__PURE__*/_react().default.createElement(_uiFoundationUiNotifications2().NotificationCenter, _extends({}, props, {
        notifications: messages
      }));
    });
    _defineProperty(this, "renderContext", ({
      children
    }) => {
      return /*#__PURE__*/_react().default.createElement(_uiFoundationUiNotifications().NotificationContext.Provider, {
        value: this
      }, children);
    });
    uiRuntimeExtension.registerHudItem( /*#__PURE__*/_react().default.createElement(this.render, {
      key: "NotificationUI"
    }));
    uiRuntimeExtension.registerRenderHooks({
      reactContext: this.renderContext
    });
  }
  /** removes/archives a message from the log */
  dismiss(id) {
    var _this$dispatch3;
    (_this$dispatch3 = this.dispatch) === null || _this$dispatch3 === void 0 || _this$dispatch3.call(this, {
      type: 'dismiss',
      id
    });
  }
}
exports.default = NotificationUI;
_defineProperty(NotificationUI, "dependencies", [_ui().UIAspect]);
_defineProperty(NotificationUI, "runtime", _ui().UIRuntime);
_notifications().NotificationsAspect.addRuntime(NotificationUI);

//# sourceMappingURL=notification.ui.runtime.js.map